package anywheresoftware.b4a.table;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.table", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.table", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public static class _rowcol{
boolean IsInitialized;
int Row;
int Col;
public void Initialize() {
IsInitialized = true;
Row = 0;
Col = 0;
}
@Override
		public String toString() {
			return BA.TypeToString(this);
		}}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.StringUtils _stringutils1 = null;
public static int _numberofcolumns = 0;
public static int _numberofrows = 0;
public static int _rowheight = 0;
public static int _rowlinewidth = 0;
public static int _rowheight_1 = 0;
public static int _collinewidth = 0;
public static int[] _columnwidth = null;
public static int[] _columnwidth_1 = null;
public static int[] _totalcolumnwidth = null;
public static int _headercolor = 0;
public static int _headerfontcolor = 0;
public static int _headerlinecolor = 0;
public static int _linecolor = 0;
public static int _cellcolor = 0;
public static int _fontcolor = 0;
public static float _fontsize = 0f;
public static int _alignment = 0;
public static int _selectedrow = 0;
public static int _selectedrowcolor = 0;
public static int _selectedcellcolor = 0;
public static float _moveleft0 = 0f;
public static float _movex0 = 0f;
public static float _movex1 = 0f;
public static float _deltascroll = 0f;
public static float _deltax = 0f;
public static long _time0 = 0L;
public anywheresoftware.b4a.objects.HorizontalScrollViewWrapper _hscrollview = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvpersons = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnlheader = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
int _i = 0;
 //BA.debugLineNum = 53;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 54;BA.debugLine="Dim i As Int";
_i = 0;
 //BA.debugLineNum = 57;BA.debugLine="TotalColumnWidth(0) = ColLineWidth";
_totalcolumnwidth[(int)(0)] = _collinewidth;
 //BA.debugLineNum = 58;BA.debugLine="For i = 0 To NumberOfColumns - 1";
{
final double step67 = 1;
final double limit67 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step67 > 0 && _i <= limit67) || (step67 < 0 && _i >= limit67); _i += step67) {
 //BA.debugLineNum = 59;BA.debugLine="ColumnWidth_1(i) = ColumnWidth(i) - ColLineWidth";
_columnwidth_1[_i] = (int)(_columnwidth[_i]-_collinewidth);
 //BA.debugLineNum = 60;BA.debugLine="TotalColumnWidth(i + 1) = TotalColumnWidth(i) + ColumnWidth(i)";
_totalcolumnwidth[(int)(_i+1)] = (int)(_totalcolumnwidth[_i]+_columnwidth[_i]);
 }
};
 //BA.debugLineNum = 63;BA.debugLine="HScrollView.Initialize(TotalColumnWidth(NumberOfColumns),\"HScrollView\")";
mostCurrent._hscrollview.Initialize(mostCurrent.activityBA,_totalcolumnwidth[_numberofcolumns],"HScrollView");
 //BA.debugLineNum = 64;BA.debugLine="Activity.AddView(HScrollView,0,0,100%x,100%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._hscrollview.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 //BA.debugLineNum = 66;BA.debugLine="scvPersons.Initialize(0)	' initialize the ScrollView";
mostCurrent._scvpersons.Initialize(mostCurrent.activityBA,(int)(0));
 //BA.debugLineNum = 67;BA.debugLine="HScrollView.Panel.AddView(scvPersons,0,RowHeight,100%x,100%y-RowHeight)";
mostCurrent._hscrollview.getPanel().AddView((android.view.View)(mostCurrent._scvpersons.getObject()),(int)(0),_rowheight,anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),(int)(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA)-_rowheight));
 //BA.debugLineNum = 70;BA.debugLine="scvPersons.Width = TotalColumnWidth(NumberOfColumns)";
mostCurrent._scvpersons.setWidth(_totalcolumnwidth[_numberofcolumns]);
 //BA.debugLineNum = 71;BA.debugLine="scvPersons.Panel.Color = LineColor";
mostCurrent._scvpersons.getPanel().setColor(_linecolor);
 //BA.debugLineNum = 73;BA.debugLine="SelectedRow = -1		' sets the selected row index to -1";
_selectedrow = (int)(-1);
 //BA.debugLineNum = 76;BA.debugLine="LoadTableFromCSV(File.DirAssets, \"persons.csv\", True)";
_loadtablefromcsv(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"persons.csv",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 78;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 84;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 86;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 80;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 82;BA.debugLine="End Sub";
return "";
}
public static String  _addrow(String[] _values) throws Exception{
int _i = 0;
anywheresoftware.b4a.objects.LabelWrapper _l = null;
main._rowcol _rc = null;
 //BA.debugLineNum = 193;BA.debugLine="Sub AddRow(Values() As String)";
 //BA.debugLineNum = 195;BA.debugLine="If Values.Length <> NumberOfColumns Then";
if (_values.length!=_numberofcolumns) { 
 //BA.debugLineNum = 196;BA.debugLine="Log(\"Wrong number of values.\")";
anywheresoftware.b4a.keywords.Common.Log("Wrong number of values.");
 //BA.debugLineNum = 197;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 200;BA.debugLine="For i = 0 To NumberOfColumns - 1";
{
final double step172 = 1;
final double limit172 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step172 > 0 && _i <= limit172) || (step172 < 0 && _i >= limit172); _i += step172) {
 //BA.debugLineNum = 201;BA.debugLine="Dim l As Label";
_l = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 202;BA.debugLine="l.Initialize(\"cell\")";
_l.Initialize(mostCurrent.activityBA,"cell");
 //BA.debugLineNum = 203;BA.debugLine="l.Text = Values(i)";
_l.setText((Object)(_values[_i]));
 //BA.debugLineNum = 204;BA.debugLine="l.Gravity = Alignment";
_l.setGravity(_alignment);
 //BA.debugLineNum = 205;BA.debugLine="l.TextSize = FontSize";
_l.setTextSize(_fontsize);
 //BA.debugLineNum = 206;BA.debugLine="l.TextColor = FontColor";
_l.setTextColor(_fontcolor);
 //BA.debugLineNum = 207;BA.debugLine="l.Color=CellColor";
_l.setColor(_cellcolor);
 //BA.debugLineNum = 208;BA.debugLine="Dim rc As RowCol";
_rc = new main._rowcol();
 //BA.debugLineNum = 209;BA.debugLine="rc.Initialize";
_rc.Initialize();
 //BA.debugLineNum = 210;BA.debugLine="rc.Col = i";
_rc.Col = _i;
 //BA.debugLineNum = 211;BA.debugLine="rc.Row = NumberOfRows";
_rc.Row = _numberofrows;
 //BA.debugLineNum = 212;BA.debugLine="l.Tag = rc";
_l.setTag((Object)(_rc));
 //BA.debugLineNum = 213;BA.debugLine="scvPersons.Panel.AddView(l, TotalColumnWidth(i), RowHeight * NumberOfRows, _ 		ColumnWidth_1(i), RowHeight_1)";
mostCurrent._scvpersons.getPanel().AddView((android.view.View)(_l.getObject()),_totalcolumnwidth[_i],(int)(_rowheight*_numberofrows),_columnwidth_1[_i],_rowheight_1);
 }
};
 //BA.debugLineNum = 216;BA.debugLine="NumberOfRows = NumberOfRows + 1";
_numberofrows = (int)(_numberofrows+1);
 //BA.debugLineNum = 217;BA.debugLine="scvPersons.Panel.Height = NumberOfRows * RowHeight";
mostCurrent._scvpersons.getPanel().setHeight((int)(_numberofrows*_rowheight));
 //BA.debugLineNum = 218;BA.debugLine="HScrollView.Panel.Height = scvPersons.Panel.Height + RowHeight";
mostCurrent._hscrollview.getPanel().setHeight((int)(mostCurrent._scvpersons.getPanel().getHeight()+_rowheight));
 //BA.debugLineNum = 219;BA.debugLine="End Sub";
return "";
}
public static String  _cell_click() throws Exception{
main._rowcol _rc = null;
anywheresoftware.b4a.objects.LabelWrapper _l = null;
 //BA.debugLineNum = 144;BA.debugLine="Sub Cell_Click";
 //BA.debugLineNum = 145;BA.debugLine="Dim rc As RowCol";
_rc = new main._rowcol();
 //BA.debugLineNum = 146;BA.debugLine="Dim l As Label";
_l = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 148;BA.debugLine="l = Sender";
_l.setObject((android.widget.TextView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 149;BA.debugLine="rc = l.Tag";
_rc = (main._rowcol)(_l.getTag());
 //BA.debugLineNum = 150;BA.debugLine="SelectRow(rc)";
_selectrow(_rc);
 //BA.debugLineNum = 151;BA.debugLine="Activity.Title = \"Cell: (\"&rc.Row&\", \"& rc.Col&\") \"&GetCell(rc.Row, rc.Col)";
mostCurrent._activity.setTitle((Object)("Cell: ("+BA.NumberToString(_rc.Row)+", "+BA.NumberToString(_rc.Col)+") "+_getcell(_rc.Row,_rc.Col)));
 //BA.debugLineNum = 152;BA.debugLine="End Sub";
return "";
}
public static String  _clearall() throws Exception{
int _i = 0;
 //BA.debugLineNum = 251;BA.debugLine="Sub ClearAll";
 //BA.debugLineNum = 253;BA.debugLine="For i = scvPersons.Panel.NumberOfViews -1 To 0 Step -1";
{
final double step215 = -1;
final double limit215 = (int)(0);
for (_i = (int)(mostCurrent._scvpersons.getPanel().getNumberOfViews()-1); (step215 > 0 && _i <= limit215) || (step215 < 0 && _i >= limit215); _i += step215) {
 //BA.debugLineNum = 254;BA.debugLine="scvPersons.Panel.RemoveViewAt(i)";
mostCurrent._scvpersons.getPanel().RemoveViewAt(_i);
 }
};
 //BA.debugLineNum = 256;BA.debugLine="scvPersons.Panel.Height = 0";
mostCurrent._scvpersons.getPanel().setHeight((int)(0));
 //BA.debugLineNum = 257;BA.debugLine="SelectedRow = -1";
_selectedrow = (int)(-1);
 //BA.debugLineNum = 258;BA.debugLine="End Sub";
return "";
}
public static String  _getcell(int _row,int _col) throws Exception{
 //BA.debugLineNum = 246;BA.debugLine="Sub GetCell(Row As Int, Col As Int) As String";
 //BA.debugLineNum = 248;BA.debugLine="Return GetView(Row, Col).Text";
if (true) return _getview(_row,_col).getText();
 //BA.debugLineNum = 249;BA.debugLine="End Sub";
return "";
}
public static anywheresoftware.b4a.objects.LabelWrapper  _getview(int _row,int _col) throws Exception{
anywheresoftware.b4a.objects.LabelWrapper _l = null;
 //BA.debugLineNum = 185;BA.debugLine="Sub GetView(Row As Int, Col As Int) As Label";
 //BA.debugLineNum = 187;BA.debugLine="Dim l As Label";
_l = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 189;BA.debugLine="l = scvPersons.Panel.GetView(Row * NumberOfColumns + Col)";
_l.setObject((android.widget.TextView)(mostCurrent._scvpersons.getPanel().GetView((int)(_row*_numberofcolumns+_col)).getObject()));
 //BA.debugLineNum = 190;BA.debugLine="Return l";
if (true) return _l;
 //BA.debugLineNum = 191;BA.debugLine="End Sub";
return null;
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 47;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 48;BA.debugLine="Dim HScrollView As HorizontalScrollView";
mostCurrent._hscrollview = new anywheresoftware.b4a.objects.HorizontalScrollViewWrapper();
 //BA.debugLineNum = 49;BA.debugLine="Dim scvPersons As ScrollView";
mostCurrent._scvpersons = new anywheresoftware.b4a.objects.ScrollViewWrapper();
 //BA.debugLineNum = 50;BA.debugLine="Dim pnlHeader As Panel";
mostCurrent._pnlheader = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 51;BA.debugLine="End Sub";
return "";
}
public static String  _header_click() throws Exception{
anywheresoftware.b4a.objects.LabelWrapper _l = null;
int _col = 0;
 //BA.debugLineNum = 154;BA.debugLine="Sub Header_Click";
 //BA.debugLineNum = 155;BA.debugLine="Dim l As Label";
_l = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 156;BA.debugLine="Dim col As Int";
_col = 0;
 //BA.debugLineNum = 158;BA.debugLine="l = Sender";
_l.setObject((android.widget.TextView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 159;BA.debugLine="col = l.Tag";
_col = (int)(BA.ObjectToNumber(_l.getTag()));
 //BA.debugLineNum = 160;BA.debugLine="Activity.Title = \"Header clicked: \" & col";
mostCurrent._activity.setTitle((Object)("Header clicked: "+BA.NumberToString(_col)));
 //BA.debugLineNum = 161;BA.debugLine="End Sub";
return "";
}
public static String  _loadtablefromcsv(String _dir,String _filename,boolean _headersexist) throws Exception{
anywheresoftware.b4a.objects.collections.List _list1 = null;
String[] _h = null;
anywheresoftware.b4a.objects.collections.List _headers = null;
int _i = 0;
String[] _firstrow = null;
String[] _row = null;
 //BA.debugLineNum = 88;BA.debugLine="Sub LoadTableFromCSV(Dir As String,Filename As String,HeadersExist As Boolean)";
 //BA.debugLineNum = 89;BA.debugLine="ClearAll	'Clears the previous table and loads the CSV file to the table";
_clearall();
 //BA.debugLineNum = 90;BA.debugLine="Dim List1 As List";
_list1 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 91;BA.debugLine="Dim h() As String";
_h = new String[(int)(0)];
java.util.Arrays.fill(_h,"");
 //BA.debugLineNum = 92;BA.debugLine="If HeadersExist Then";
if (_headersexist) { 
 //BA.debugLineNum = 94;BA.debugLine="Dim headers As List";
_headers = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 95;BA.debugLine="List1 = StringUtils1.LoadCSV2(Dir, Filename, \",\", headers)";
_list1 = _stringutils1.LoadCSV2(_dir,_filename,BA.ObjectToChar(","),_headers);
 //BA.debugLineNum = 97;BA.debugLine="Dim h(headers.Size) As String";
_h = new String[_headers.getSize()];
java.util.Arrays.fill(_h,"");
 //BA.debugLineNum = 98;BA.debugLine="For i = 0 To headers.Size - 1";
{
final double step92 = 1;
final double limit92 = (int)(_headers.getSize()-1);
for (_i = (int)(0); (step92 > 0 && _i <= limit92) || (step92 < 0 && _i >= limit92); _i += step92) {
 //BA.debugLineNum = 99;BA.debugLine="h(i) = headers.Get(i)";
_h[_i] = String.valueOf(_headers.Get(_i));
 }
};
 }else {
 //BA.debugLineNum = 103;BA.debugLine="List1 = StringUtils1.LoadCSV(Dir, Filename, \",\")";
_list1 = _stringutils1.LoadCSV(_dir,_filename,BA.ObjectToChar(","));
 //BA.debugLineNum = 105;BA.debugLine="Dim firstRow() As String";
_firstrow = new String[(int)(0)];
java.util.Arrays.fill(_firstrow,"");
 //BA.debugLineNum = 106;BA.debugLine="firstRow = List1.Get(0)";
_firstrow = (String[])(_list1.Get((int)(0)));
 //BA.debugLineNum = 107;BA.debugLine="Dim h(firstRow.Length)";
_h = new String[_firstrow.length];
java.util.Arrays.fill(_h,"");
 //BA.debugLineNum = 108;BA.debugLine="For i = 0 To firstRow.Length - 1";
{
final double step100 = 1;
final double limit100 = (int)(_firstrow.length-1);
for (_i = (int)(0); (step100 > 0 && _i <= limit100) || (step100 < 0 && _i >= limit100); _i += step100) {
 //BA.debugLineNum = 109;BA.debugLine="h(i) = \"Col\" & (i + 1)";
_h[_i] = "Col"+BA.NumberToString((_i+1));
 }
};
 };
 //BA.debugLineNum = 112;BA.debugLine="NumberOfColumns = h.Length	' Gets the number of columns";
_numberofcolumns = _h.length;
 //BA.debugLineNum = 113;BA.debugLine="SetHeader(h)		' Sets the headers";
_setheader(_h);
 //BA.debugLineNum = 115;BA.debugLine="NumberOfRows = 0";
_numberofrows = (int)(0);
 //BA.debugLineNum = 116;BA.debugLine="For i = 0 To List1.Size - 1";
{
final double step107 = 1;
final double limit107 = (int)(_list1.getSize()-1);
for (_i = (int)(0); (step107 > 0 && _i <= limit107) || (step107 < 0 && _i >= limit107); _i += step107) {
 //BA.debugLineNum = 118;BA.debugLine="Dim row() As String";
_row = new String[(int)(0)];
java.util.Arrays.fill(_row,"");
 //BA.debugLineNum = 119;BA.debugLine="row = List1.Get(i)";
_row = (String[])(_list1.Get(_i));
 //BA.debugLineNum = 120;BA.debugLine="AddRow(row)";
_addrow(_row);
 }
};
 //BA.debugLineNum = 122;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 1;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 2;BA.debugLine="Dim StringUtils1 As StringUtils";
_stringutils1 = new anywheresoftware.b4a.objects.StringUtils();
 //BA.debugLineNum = 4;BA.debugLine="Dim NumberOfColumns As Int			: NumberOfColumns = 17";
_numberofcolumns = 0;
 //BA.debugLineNum = 4;BA.debugLine="Dim NumberOfColumns As Int			: NumberOfColumns = 17";
_numberofcolumns = (int)(17);
 //BA.debugLineNum = 5;BA.debugLine="Dim NumberOfRows As Int";
_numberofrows = 0;
 //BA.debugLineNum = 6;BA.debugLine="Dim RowHeight As Int						: RowHeight = 30dip";
_rowheight = 0;
 //BA.debugLineNum = 6;BA.debugLine="Dim RowHeight As Int						: RowHeight = 30dip";
_rowheight = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(30));
 //BA.debugLineNum = 7;BA.debugLine="Dim RowLineWidth As Int					: RowLineWidth = 1dip";
_rowlinewidth = 0;
 //BA.debugLineNum = 7;BA.debugLine="Dim RowLineWidth As Int					: RowLineWidth = 1dip";
_rowlinewidth = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1));
 //BA.debugLineNum = 8;BA.debugLine="Dim RowHeight_1 As Int					: RowHeight_1 = RowHeight - RowLineWidth";
_rowheight_1 = 0;
 //BA.debugLineNum = 8;BA.debugLine="Dim RowHeight_1 As Int					: RowHeight_1 = RowHeight - RowLineWidth";
_rowheight_1 = (int)(_rowheight-_rowlinewidth);
 //BA.debugLineNum = 9;BA.debugLine="Dim ColLineWidth As Int					: ColLineWidth = 1dip";
_collinewidth = 0;
 //BA.debugLineNum = 9;BA.debugLine="Dim ColLineWidth As Int					: ColLineWidth = 1dip";
_collinewidth = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1));
 //BA.debugLineNum = 10;BA.debugLine="Dim ColumnWidth(NumberOfColumns) As Int";
_columnwidth = new int[_numberofcolumns];
;
 //BA.debugLineNum = 11;BA.debugLine="ColumnWidth(0) = 50dip";
_columnwidth[(int)(0)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(50));
 //BA.debugLineNum = 12;BA.debugLine="ColumnWidth(1) = 100dip";
_columnwidth[(int)(1)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 13;BA.debugLine="ColumnWidth(2) = 100dip";
_columnwidth[(int)(2)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 14;BA.debugLine="ColumnWidth(3) = 150dip";
_columnwidth[(int)(3)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(150));
 //BA.debugLineNum = 15;BA.debugLine="ColumnWidth(4) = 100dip";
_columnwidth[(int)(4)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 16;BA.debugLine="ColumnWidth(5) = 100dip";
_columnwidth[(int)(5)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 17;BA.debugLine="ColumnWidth(6) = 100dip";
_columnwidth[(int)(6)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 18;BA.debugLine="ColumnWidth(7) = 100dip";
_columnwidth[(int)(7)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 19;BA.debugLine="ColumnWidth(8) = 100dip";
_columnwidth[(int)(8)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 20;BA.debugLine="ColumnWidth(9) = 100dip";
_columnwidth[(int)(9)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 21;BA.debugLine="ColumnWidth(10) = 100dip";
_columnwidth[(int)(10)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 22;BA.debugLine="ColumnWidth(11) = 100dip";
_columnwidth[(int)(11)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 23;BA.debugLine="ColumnWidth(12) = 100dip";
_columnwidth[(int)(12)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 24;BA.debugLine="ColumnWidth(13) = 100dip";
_columnwidth[(int)(13)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 25;BA.debugLine="ColumnWidth(14) = 100dip";
_columnwidth[(int)(14)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 26;BA.debugLine="ColumnWidth(15) = 100dip";
_columnwidth[(int)(15)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 27;BA.debugLine="ColumnWidth(16) = 100dip";
_columnwidth[(int)(16)] = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100));
 //BA.debugLineNum = 28;BA.debugLine="Dim ColumnWidth_1(NumberOfColumns) As Int";
_columnwidth_1 = new int[_numberofcolumns];
;
 //BA.debugLineNum = 29;BA.debugLine="Dim TotalColumnWidth(NumberOfColumns + 1) As Int";
_totalcolumnwidth = new int[(int)(_numberofcolumns+1)];
;
 //BA.debugLineNum = 31;BA.debugLine="Dim HeaderColor As Int					: HeaderColor = Colors.Blue";
_headercolor = 0;
 //BA.debugLineNum = 31;BA.debugLine="Dim HeaderColor As Int					: HeaderColor = Colors.Blue";
_headercolor = anywheresoftware.b4a.keywords.Common.Colors.Blue;
 //BA.debugLineNum = 32;BA.debugLine="Dim HeaderFontColor As Int			: HeaderFontColor = Colors.Yellow";
_headerfontcolor = 0;
 //BA.debugLineNum = 32;BA.debugLine="Dim HeaderFontColor As Int			: HeaderFontColor = Colors.Yellow";
_headerfontcolor = anywheresoftware.b4a.keywords.Common.Colors.Yellow;
 //BA.debugLineNum = 33;BA.debugLine="Dim HeaderLineColor As Int			: HeaderLineColor = Colors.Yellow";
_headerlinecolor = 0;
 //BA.debugLineNum = 33;BA.debugLine="Dim HeaderLineColor As Int			: HeaderLineColor = Colors.Yellow";
_headerlinecolor = anywheresoftware.b4a.keywords.Common.Colors.Yellow;
 //BA.debugLineNum = 34;BA.debugLine="Dim LineColor As Int						: LineColor = Colors.Black";
_linecolor = 0;
 //BA.debugLineNum = 34;BA.debugLine="Dim LineColor As Int						: LineColor = Colors.Black";
_linecolor = anywheresoftware.b4a.keywords.Common.Colors.Black;
 //BA.debugLineNum = 35;BA.debugLine="Dim CellColor As Int						: CellColor = Colors.RGB(255,255,220)";
_cellcolor = 0;
 //BA.debugLineNum = 35;BA.debugLine="Dim CellColor As Int						: CellColor = Colors.RGB(255,255,220)";
_cellcolor = anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(255),(int)(220));
 //BA.debugLineNum = 36;BA.debugLine="Dim FontColor As Int						: FontColor = Colors.Black";
_fontcolor = 0;
 //BA.debugLineNum = 36;BA.debugLine="Dim FontColor As Int						: FontColor = Colors.Black";
_fontcolor = anywheresoftware.b4a.keywords.Common.Colors.Black;
 //BA.debugLineNum = 37;BA.debugLine="Dim FontSize As Float						: FontSize = 14";
_fontsize = 0f;
 //BA.debugLineNum = 37;BA.debugLine="Dim FontSize As Float						: FontSize = 14";
_fontsize = (float)(14);
 //BA.debugLineNum = 38;BA.debugLine="Dim Alignment As Int						: Alignment = Gravity.CENTER";
_alignment = 0;
 //BA.debugLineNum = 38;BA.debugLine="Dim Alignment As Int						: Alignment = Gravity.CENTER";
_alignment = anywheresoftware.b4a.keywords.Common.Gravity.CENTER;
 //BA.debugLineNum = 39;BA.debugLine="Dim SelectedRow As Int					: SelectedRow = -1";
_selectedrow = 0;
 //BA.debugLineNum = 39;BA.debugLine="Dim SelectedRow As Int					: SelectedRow = -1";
_selectedrow = (int)(-1);
 //BA.debugLineNum = 40;BA.debugLine="Dim SelectedRowColor As Int			: SelectedRowColor=Colors.RGB(255,196,255)";
_selectedrowcolor = 0;
 //BA.debugLineNum = 40;BA.debugLine="Dim SelectedRowColor As Int			: SelectedRowColor=Colors.RGB(255,196,255)";
_selectedrowcolor = anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(196),(int)(255));
 //BA.debugLineNum = 41;BA.debugLine="Dim SelectedCellColor As Int		: SelectedCellColor=Colors.RGB(255,150,255)";
_selectedcellcolor = 0;
 //BA.debugLineNum = 41;BA.debugLine="Dim SelectedCellColor As Int		: SelectedCellColor=Colors.RGB(255,150,255)";
_selectedcellcolor = anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(150),(int)(255));
 //BA.debugLineNum = 42;BA.debugLine="Type RowCol (Row As Int, Col As Int)";
;
 //BA.debugLineNum = 43;BA.debugLine="Dim MoveLeft0, MoveX0, MoveX1, DeltaScroll, DeltaX As Float";
_moveleft0 = 0f;
_movex0 = 0f;
_movex1 = 0f;
_deltascroll = 0f;
_deltax = 0f;
 //BA.debugLineNum = 44;BA.debugLine="Dim Time0 As Long";
_time0 = 0L;
 //BA.debugLineNum = 45;BA.debugLine="End Sub";
return "";
}
public static String  _savetabletocsv(String _dir,String _filename) throws Exception{
String[] _headers = null;
int _i = 0;
anywheresoftware.b4a.objects.LabelWrapper _l = null;
anywheresoftware.b4a.objects.collections.List _list1 = null;
String[] _row = null;
int _c = 0;
 //BA.debugLineNum = 124;BA.debugLine="Sub SaveTableToCSV(Dir As String, Filename As String)";
 //BA.debugLineNum = 126;BA.debugLine="Dim headers(NumberOfColumns) As String";
_headers = new String[_numberofcolumns];
java.util.Arrays.fill(_headers,"");
 //BA.debugLineNum = 127;BA.debugLine="For i = 0 To headers.Length - 1";
{
final double step115 = 1;
final double limit115 = (int)(_headers.length-1);
for (_i = (int)(0); (step115 > 0 && _i <= limit115) || (step115 < 0 && _i >= limit115); _i += step115) {
 //BA.debugLineNum = 128;BA.debugLine="Dim l As Label";
_l = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 129;BA.debugLine="l = pnlHeader.GetView(i)";
_l.setObject((android.widget.TextView)(mostCurrent._pnlheader.GetView(_i).getObject()));
 //BA.debugLineNum = 130;BA.debugLine="headers(i) = l.Text";
_headers[_i] = _l.getText();
 }
};
 //BA.debugLineNum = 132;BA.debugLine="Dim list1 As List";
_list1 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 133;BA.debugLine="list1.Initialize";
_list1.Initialize();
 //BA.debugLineNum = 134;BA.debugLine="For i = 0 To NumberOfRows - 1";
{
final double step122 = 1;
final double limit122 = (int)(_numberofrows-1);
for (_i = (int)(0); (step122 > 0 && _i <= limit122) || (step122 < 0 && _i >= limit122); _i += step122) {
 //BA.debugLineNum = 135;BA.debugLine="Dim row(NumberOfColumns) As String";
_row = new String[_numberofcolumns];
java.util.Arrays.fill(_row,"");
 //BA.debugLineNum = 136;BA.debugLine="For c = 0 To NumberOfColumns - 1";
{
final double step124 = 1;
final double limit124 = (int)(_numberofcolumns-1);
for (_c = (int)(0); (step124 > 0 && _c <= limit124) || (step124 < 0 && _c >= limit124); _c += step124) {
 //BA.debugLineNum = 137;BA.debugLine="row(c) = GetCell(i, c)";
_row[_c] = _getcell(_i,_c);
 }
};
 //BA.debugLineNum = 139;BA.debugLine="list1.Add(row)";
_list1.Add((Object)(_row));
 }
};
 //BA.debugLineNum = 141;BA.debugLine="StringUtils1.SaveCSV2(Dir, Filename, \",\", list1, headers)";
_stringutils1.SaveCSV2(_dir,_filename,BA.ObjectToChar(","),_list1,anywheresoftware.b4a.keywords.Common.ArrayToList(_headers));
 //BA.debugLineNum = 142;BA.debugLine="End Sub";
return "";
}
public static String  _selectrow(main._rowcol _rc) throws Exception{
int _col = 0;
 //BA.debugLineNum = 163;BA.debugLine="Sub SelectRow(rc As RowCol)";
 //BA.debugLineNum = 164;BA.debugLine="Dim col As Int";
_col = 0;
 //BA.debugLineNum = 167;BA.debugLine="If SelectedRow > -1 Then";
if (_selectedrow>-1) { 
 //BA.debugLineNum = 168;BA.debugLine="For col = 0 To NumberOfColumns - 1";
{
final double step149 = 1;
final double limit149 = (int)(_numberofcolumns-1);
for (_col = (int)(0); (step149 > 0 && _col <= limit149) || (step149 < 0 && _col >= limit149); _col += step149) {
 //BA.debugLineNum = 169;BA.debugLine="GetView(SelectedRow, col).Color = CellColor";
_getview(_selectedrow,_col).setColor(_cellcolor);
 }
};
 };
 //BA.debugLineNum = 173;BA.debugLine="SelectedRow = rc.Row";
_selectedrow = _rc.Row;
 //BA.debugLineNum = 176;BA.debugLine="For col = 0 To NumberOfColumns - 1";
{
final double step154 = 1;
final double limit154 = (int)(_numberofcolumns-1);
for (_col = (int)(0); (step154 > 0 && _col <= limit154) || (step154 < 0 && _col >= limit154); _col += step154) {
 //BA.debugLineNum = 177;BA.debugLine="If col = rc.col Then";
if (_col==_rc.Col) { 
 //BA.debugLineNum = 178;BA.debugLine="GetView(rc.Row, col).Color = SelectedCellColor";
_getview(_rc.Row,_col).setColor(_selectedcellcolor);
 }else {
 //BA.debugLineNum = 180;BA.debugLine="GetView(rc.Row, col).Color = SelectedRowColor";
_getview(_rc.Row,_col).setColor(_selectedrowcolor);
 };
 }
};
 //BA.debugLineNum = 183;BA.debugLine="End Sub";
return "";
}
public static String  _setcell(int _row,int _col,String _value) throws Exception{
 //BA.debugLineNum = 241;BA.debugLine="Sub SetCell(Row As Int, Col As Int, Value As String)";
 //BA.debugLineNum = 243;BA.debugLine="GetView(Row, Col).Text = Value";
_getview(_row,_col).setText((Object)(_value));
 //BA.debugLineNum = 244;BA.debugLine="End Sub";
return "";
}
public static String  _setheader(String[] _values) throws Exception{
int _i = 0;
anywheresoftware.b4a.objects.LabelWrapper _l = null;
 //BA.debugLineNum = 221;BA.debugLine="Sub SetHeader(Values() As String)";
 //BA.debugLineNum = 223;BA.debugLine="If pnlHeader.IsInitialized Then Return 'should only be called once";
if (mostCurrent._pnlheader.IsInitialized()) { 
if (true) return "";};
 //BA.debugLineNum = 224;BA.debugLine="pnlHeader.Initialize(\"\")";
mostCurrent._pnlheader.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 225;BA.debugLine="pnlHeader.Color = HeaderLineColor";
mostCurrent._pnlheader.setColor(_headerlinecolor);
 //BA.debugLineNum = 226;BA.debugLine="For i = 0 To NumberOfColumns - 1";
{
final double step195 = 1;
final double limit195 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step195 > 0 && _i <= limit195) || (step195 < 0 && _i >= limit195); _i += step195) {
 //BA.debugLineNum = 227;BA.debugLine="Dim l As Label";
_l = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 228;BA.debugLine="l.Initialize(\"Header\")";
_l.Initialize(mostCurrent.activityBA,"Header");
 //BA.debugLineNum = 229;BA.debugLine="l.Text = Values(i)";
_l.setText((Object)(_values[_i]));
 //BA.debugLineNum = 230;BA.debugLine="l.Gravity = Gravity.CENTER";
_l.setGravity(anywheresoftware.b4a.keywords.Common.Gravity.CENTER);
 //BA.debugLineNum = 231;BA.debugLine="l.TextSize = FontSize";
_l.setTextSize(_fontsize);
 //BA.debugLineNum = 232;BA.debugLine="l.Color = HeaderColor";
_l.setColor(_headercolor);
 //BA.debugLineNum = 233;BA.debugLine="l.TextColor = HeaderFontColor";
_l.setTextColor(_headerfontcolor);
 //BA.debugLineNum = 234;BA.debugLine="l.Tag = i";
_l.setTag((Object)(_i));
 //BA.debugLineNum = 235;BA.debugLine="pnlHeader.AddView(l,TotalColumnWidth(i),0,ColumnWidth_1(i),RowHeight_1)";
mostCurrent._pnlheader.AddView((android.view.View)(_l.getObject()),_totalcolumnwidth[_i],(int)(0),_columnwidth_1[_i],_rowheight_1);
 }
};
 //BA.debugLineNum = 237;BA.debugLine="HScrollView.Panel.AddView(pnlHeader,scvPersons.Left,0,scvPersons.Width,RowHeight)";
mostCurrent._hscrollview.getPanel().AddView((android.view.View)(mostCurrent._pnlheader.getObject()),mostCurrent._scvpersons.getLeft(),(int)(0),mostCurrent._scvpersons.getWidth(),_rowheight);
 //BA.debugLineNum = 239;BA.debugLine="End Sub";
return "";
}
}
